=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2008-02-13 03:25:53 +0000
+++ bzrlib/__init__.py	2008-02-18 08:30:38 +0000
@@ -16,20 +16,19 @@
 
 """bzr library"""
 
+#from bzrlib.osutils import get_user_encoding
 import time
 
 # Keep track of when bzrlib was first imported, so that we can give rough
 # timestamps relative to program start in the log file kept by bzrlib.trace.
 _start_time = time.time()
 
-from bzrlib.osutils import get_user_encoding
-
 
 IGNORE_FILENAME = ".bzrignore"
 
 
 # XXX: Compatibility. This should probably be deprecated
-user_encoding = get_user_encoding()
+#user_encoding = get_user_encoding()
 
 
 __copyright__ = "Copyright 2005, 2006, 2007, 2008 Canonical Ltd."

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2008-02-01 00:30:33 +0000
+++ bzrlib/builtins.py	2008-02-18 08:30:38 +0000
@@ -17,11 +17,11 @@
 """builtin bzr commands"""
 
 import os
-from StringIO import StringIO
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 import codecs
+import cStringIO
 import sys
 import time
 
@@ -2306,7 +2306,7 @@
             if my_message is None and not file:
                 t = make_commit_message_template_encoded(tree,
                         selected_list, diff=show_diff,
-                        output_encoding=bzrlib.user_encoding)
+                        output_encoding=osutils.get_user_encoding())
                 my_message = edit_commit_message_encoded(t)
                 if my_message is None:
                     raise errors.BzrCommandError("please specify a commit"
@@ -4068,7 +4068,7 @@
         from bzrlib.revision import NULL_REVISION
         branch = Branch.open_containing(from_)[0]
         if output is None:
-            outfile = StringIO()
+            outfile = cStringIO.StringIO()
         elif output == '-':
             outfile = self.outf
         else:

=== modified file 'bzrlib/bundle/__init__.py'
--- bzrlib/bundle/__init__.py	2007-06-05 15:52:12 +0000
+++ bzrlib/bundle/__init__.py	2008-02-18 08:30:38 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from StringIO import StringIO
-
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from bzrlib import (

=== modified file 'bzrlib/cmd_version_info.py'
--- bzrlib/cmd_version_info.py	2007-11-10 11:25:36 +0000
+++ bzrlib/cmd_version_info.py	2008-02-18 08:30:38 +0000
@@ -22,11 +22,9 @@
     branch,
     errors,
     workingtree,
+    version_info_formats,
     )
 """)
-from bzrlib import (
-    version_info_formats,
-    )
 from bzrlib.commands import Command
 from bzrlib.option import Option, RegistryOption
 
@@ -72,8 +70,9 @@
 
     takes_options = [RegistryOption('format',
                             'Select the output format.',
-                            version_info_formats.format_registry,
-                            value_switches=True),
+                            value_switches=True,
+                            lazy_registry=('bzrlib.version_info_formats',
+                                           'format_registry')),
                      Option('all', help='Include all possible information.'),
                      Option('check-clean', help='Check if tree is clean.'),
                      Option('include-history',

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2008-01-21 05:44:29 +0000
+++ bzrlib/commands.py	2008-02-18 08:30:38 +0000
@@ -761,7 +761,8 @@
     if not opt_no_aliases:
         alias_argv = get_alias(argv[0])
         if alias_argv:
-            alias_argv = [a.decode(bzrlib.user_encoding) for a in alias_argv]
+            user_encoding = osutils.get_user_encoding()
+            alias_argv = [a.decode(user_encoding) for a in alias_argv]
             argv[0] = alias_argv.pop(0)
 
     cmd = argv.pop(0)
@@ -818,7 +819,8 @@
     from bzrlib.ui.text import TextUIFactory
     bzrlib.ui.ui_factory = TextUIFactory()
     try:
-        argv = [a.decode(bzrlib.user_encoding) for a in argv[1:]]
+        user_encoding = osutils.get_user_encoding()
+        argv = [a.decode(user_encoding) for a in argv[1:]]
     except UnicodeDecodeError:
         raise errors.BzrError(("Parameter '%r' is unsupported by the current "
                                                             "encoding." % a))

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2007-12-21 06:34:27 +0000
+++ bzrlib/commit.py	2008-02-18 08:30:38 +0000
@@ -68,7 +68,8 @@
                            ConflictsInTree,
                            StrictCommitFailed
                            )
-from bzrlib.osutils import (kind_marker, isdir,isfile, is_inside_any,
+from bzrlib.osutils import (get_user_encoding,
+                            kind_marker, isdir,isfile, is_inside_any,
                             is_inside_or_parent_of_any,
                             minimum_path_selection,
                             quotefn, sha_file, split_lines,
@@ -76,7 +77,6 @@
                             )
 from bzrlib.testament import Testament
 from bzrlib.trace import mutter, note, warning, is_quiet
-from bzrlib.xml5 import serializer_v5
 from bzrlib.inventory import InventoryEntry, make_entry
 from bzrlib import symbol_versioning
 from bzrlib.symbol_versioning import (deprecated_passed,
@@ -246,7 +246,7 @@
         if message_callback is None:
             if message is not None:
                 if isinstance(message, str):
-                    message = message.decode(bzrlib.user_encoding)
+                    message = message.decode(get_user_encoding())
                 message_callback = lambda x: message
             else:
                 raise BzrError("The message or message_callback keyword"

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2008-02-12 02:13:43 +0000
+++ bzrlib/errors.py	2008-02-18 08:30:38 +0000
@@ -19,7 +19,6 @@
 
 
 from bzrlib import (
-    osutils,
     symbol_versioning,
     )
 from bzrlib.patches import (
@@ -1761,6 +1760,7 @@
     _fmt = "Could not move %(from_path)s%(operator)s %(to_path)s%(extra)s"
 
     def __init__(self, from_path='', to_path='', extra=None):
+        from bzrlib.osutils import splitpath
         BzrError.__init__(self)
         if extra:
             self.extra = ': ' + str(extra)
@@ -1770,12 +1770,12 @@
         has_from = len(from_path) > 0
         has_to = len(to_path) > 0
         if has_from:
-            self.from_path = osutils.splitpath(from_path)[-1]
+            self.from_path = splitpath(from_path)[-1]
         else:
             self.from_path = ''
 
         if has_to:
-            self.to_path = osutils.splitpath(to_path)[-1]
+            self.to_path = splitpath(to_path)[-1]
         else:
             self.to_path = ''
 

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2008-02-08 03:18:35 +0000
+++ bzrlib/knit.py	2008-02-18 08:30:38 +0000
@@ -75,8 +75,10 @@
 from bzrlib import (
     annotate,
     lru_cache,
+    merge,
     pack,
     trace,
+    tsort,
     )
 """)
 from bzrlib import (
@@ -87,7 +89,6 @@
     osutils,
     patiencediff,
     progress,
-    merge,
     ui,
     )
 from bzrlib.errors import (
@@ -108,7 +109,6 @@
     sha_strings,
     )
 from bzrlib.symbol_versioning import DEPRECATED_PARAMETER, deprecated_passed
-from bzrlib.tsort import topo_sort
 import bzrlib.ui
 import bzrlib.weave
 from bzrlib.versionedfile import VersionedFile, InterVersionedFile
@@ -1401,7 +1401,7 @@
             graph[version] = parents
         if not topo_sorted:
             return graph.keys()
-        return topo_sort(graph.items())
+        return tsort.topo_sort(graph.items())
 
     def get_ancestry_with_ghosts(self, versions):
         """See VersionedFile.get_ancestry_with_ghosts."""
@@ -1421,7 +1421,7 @@
                 # if not completed
                 pending.update([p for p in parents if p not in graph])
                 graph[version] = parents
-        return topo_sort(graph.items())
+        return tsort.topo_sort(graph.items())
 
     def get_build_details(self, version_ids):
         """Get the method, index_memo and compression parent for version_ids.
@@ -1664,7 +1664,7 @@
         if versions.difference(graph):
             raise RevisionNotPresent(versions.difference(graph).pop(), self)
         if topo_sorted:
-            result_keys = topo_sort(graph.items())
+            result_keys = tsort.topo_sort(graph.items())
         else:
             result_keys = graph.iterkeys()
         return [key[0] for key in result_keys]
@@ -1700,7 +1700,7 @@
                 # add a key, no parents
                 graph[missing_version] = []
                 pending.discard(missing_version) # don't look for it
-        result_keys = topo_sort(graph.items())
+        result_keys = tsort.topo_sort(graph.items())
         return [key[0] for key in result_keys]
 
     def get_build_details(self, version_ids):
@@ -2529,7 +2529,7 @@
         """
         version_ids = self._get_source_version_ids(version_ids, ignore_missing)
         graph = self.source.get_graph(version_ids)
-        order = topo_sort(graph.items())
+        order = tsort.topo_sort(graph.items())
 
         def size_of_content(content):
             return sum(len(line) for line in content.text())
@@ -2596,7 +2596,7 @@
     
             if not needed_versions:
                 return 0
-            full_list = topo_sort(self.source.get_graph())
+            full_list = tsort.topo_sort(self.source.get_graph())
     
             version_list = [i for i in full_list if (not self.target.has_version(i)
                             and i in needed_versions)]
@@ -2698,7 +2698,7 @@
     
             if not needed_versions:
                 return 0
-            full_list = topo_sort(self.source.get_graph())
+            full_list = tsort.topo_sort(self.source.get_graph())
     
             version_list = [i for i in full_list if (not self.target.has_version(i)
                             and i in needed_versions)]

=== modified file 'bzrlib/lock.py'
--- bzrlib/lock.py	2007-10-03 08:06:44 +0000
+++ bzrlib/lock.py	2008-02-18 08:30:38 +0000
@@ -88,16 +88,14 @@
     have_fcntl = True
 except ImportError:
     have_fcntl = False
-try:
-    import win32con, win32file, pywintypes, winerror, msvcrt
-    have_pywin32 = True
-except ImportError:
-    have_pywin32 = False
-try:
-    import ctypes, msvcrt
-    have_ctypes = True
-except ImportError:
-    have_ctypes = False
+
+have_pywin32 = False
+if sys.platform == 'win32':
+    try:
+        import win32con, win32file, pywintypes, winerror, msvcrt
+        have_pywin32 = True
+    except ImportError:
+        pass
 
 
 _lock_classes = []
@@ -328,7 +326,15 @@
     _lock_classes.append(('pywin32', _w32c_WriteLock, _w32c_ReadLock))
 
 
-if have_ctypes and sys.platform == 'win32':
+have_ctypes_win32 = False
+if sys.platform == 'win32':
+    try:
+        import ctypes, msvcrt
+        have_ctypes_win32 = True
+    except ImportError:
+        pass
+
+if have_ctypes_win32:
     # These constants were copied from the win32con.py module.
     LOCKFILE_FAIL_IMMEDIATELY = 1
     LOCKFILE_EXCLUSIVE_LOCK = 2

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2007-12-05 18:47:51 +0000
+++ bzrlib/log.py	2008-02-18 08:30:38 +0000
@@ -59,35 +59,32 @@
     warn,
     )
 
+from bzrlib.lazy_import import lazy_import
+lazy_import(globals(), """
+from bzrlib import (
+    errors,
+    revision,
+    revisionspec,
+    tsort,
+    )
+""")
+
 from bzrlib import (
     config,
     lazy_regex,
     registry,
     symbol_versioning,
     )
-from bzrlib.errors import (
-    BzrCommandError,
-    )
 from bzrlib.osutils import (
     format_date,
     get_terminal_encoding,
     terminal_width,
     )
-from bzrlib.revision import (
-    NULL_REVISION,
-    )
-from bzrlib.revisionspec import (
-    RevisionInfo,
-    )
 from bzrlib.symbol_versioning import (
     deprecated_method,
     zero_seventeen,
     )
 from bzrlib.trace import mutter
-from bzrlib.tsort import (
-    merge_sort,
-    topo_sort,
-    )
 
 
 def find_touching_revisions(branch, file_id):
@@ -249,7 +246,7 @@
         generate_single_revision = ((start_rev_id == end_rev_id)
             and getattr(lf, 'supports_single_merge_revision', False))
         if not generate_single_revision:
-            raise BzrCommandError('Selected log formatter only supports '
+            raise errors.BzrCommandError('Selected log formatter only supports '
                 'mainline revisions.')
         generate_merge_revisions = generate_single_revision
     view_revs_iter = get_view_revisions(mainline_revs, rev_nos, branch,
@@ -363,7 +360,7 @@
     if start_revision is None:
         start_revno = 1
     else:
-        if isinstance(start_revision,RevisionInfo):
+        if isinstance(start_revision, revisionspec.RevisionInfo):
             start_rev_id = start_revision.rev_id
             start_revno = start_revision.revno or 1
         else:
@@ -374,19 +371,19 @@
     if end_revision is None:
         end_revno = len(which_revs)
     else:
-        if isinstance(end_revision,RevisionInfo):
+        if isinstance(end_revision, revisionspec.RevisionInfo):
             end_rev_id = end_revision.rev_id
             end_revno = end_revision.revno or len(which_revs)
         else:
             branch.check_real_revno(end_revision)
             end_revno = end_revision
 
-    if ((start_rev_id == NULL_REVISION)
-        or (end_rev_id == NULL_REVISION)):
-        raise BzrCommandError('Logging revision 0 is invalid.')
+    if ((start_rev_id == revision.NULL_REVISION)
+        or (end_rev_id == revision.NULL_REVISION)):
+        raise errors.BzrCommandError('Logging revision 0 is invalid.')
     if start_revno > end_revno:
-        raise BzrCommandError("Start revision must be older than "
-                              "the end revision.")
+        raise errors.BzrCommandError("Start revision must be older than "
+                                     "the end revision.")
 
     # list indexes are 0-based; revisions are 1-based
     cut_revs = which_revs[(start_revno-1):(end_revno)]
@@ -475,7 +472,7 @@
     # build the ancestry of each revision in the graph
     # - only listing the ancestors that change the specific file.
     rev_graph = branch.repository.get_revision_graph(mainline_revisions[-1])
-    sorted_rev_list = topo_sort(rev_graph)
+    sorted_rev_list = tsort.topo_sort(rev_graph)
     ancestry = {}
     for rev in sorted_rev_list:
         parents = rev_graph[rev]
@@ -520,7 +517,7 @@
         for revision_id in revision_ids:
             yield revision_id, str(rev_nos[revision_id]), 0
         return
-    merge_sorted_revisions = merge_sort(
+    merge_sorted_revisions = tsort.merge_sort(
         branch.repository.get_revision_graph(mainline_revs[-1]),
         mainline_revs[-1],
         mainline_revs,
@@ -827,7 +824,7 @@
     try:
         return log_formatter_registry.make_formatter(name, *args, **kwargs)
     except KeyError:
-        raise BzrCommandError("unknown log formatter: %r" % name)
+        raise errors.BzrCommandError("unknown log formatter: %r" % name)
 
 
 def show_one_log(revno, rev, delta, verbose, to_file, show_timezone):

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2007-11-17 17:22:08 +0000
+++ bzrlib/msgeditor.py	2008-02-18 08:30:38 +0000
@@ -23,7 +23,6 @@
 from subprocess import call
 import sys
 
-import bzrlib
 import bzrlib.config as config
 from bzrlib import osutils
 from bzrlib.errors import BzrError, BadCommitMessageEncoding
@@ -102,8 +101,8 @@
     """
 
     if not start_message is None:
-        start_message = start_message.encode(bzrlib.user_encoding)
-    infotext = infotext.encode(bzrlib.user_encoding, 'replace')
+        start_message = start_message.encode(osutils.get_user_encoding())
+    infotext = infotext.encode(osutils.get_user_encoding(), 'replace')
     return edit_commit_message_encoded(infotext, ignoreline, start_message)
 
 
@@ -144,7 +143,7 @@
         f = file(msgfilename, 'rU')
         try:
             try:
-                for line in codecs.getreader(bzrlib.user_encoding)(f):
+                for line in codecs.getreader(osutils.get_user_encoding())(f):
                     stripped_line = line.strip()
                     # strip empty line before the log message starts
                     if not started:

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2007-12-28 20:10:14 +0000
+++ bzrlib/option.py	2008-02-18 08:30:38 +0000
@@ -26,7 +26,7 @@
 from bzrlib import (
     errors,
     log,
-    registry,
+    registry as _mod_registry,
     revisionspec,
     symbol_versioning,
     )
@@ -306,8 +306,9 @@
         else:
             return self.converter(value)
 
-    def __init__(self, name, help, registry, converter=None,
-        value_switches=False, title=None, enum_switch=True):
+    def __init__(self, name, help, registry=None, converter=None,
+        value_switches=False, title=None, enum_switch=True,
+        lazy_registry=None):
         """
         Constructor.
 
@@ -321,9 +322,16 @@
             '--knit' can be used interchangeably.
         :param enum_switch: If true, a switch is provided with the option name,
             which takes a value.
+        :param lazy_registry: A tuple of (module name, attribute name) for a
+            registry to be lazily loaded.
         """
         Option.__init__(self, name, help, type=self.convert)
-        self.registry = registry
+        self._registry = registry
+        if registry is None:
+            assert lazy_registry is not None, (
+                'One of registry or lazy_registry must be given.')
+            self._lazy_registry = _mod_registry._LazyObjectGetter(
+                *lazy_registry)
         self.name = name
         self.converter = converter
         self.value_switches = value_switches
@@ -332,6 +340,13 @@
         if self.title is None:
             self.title = name
 
+    @property
+    def registry(self):
+        if self._registry is not None:
+            return self._registry
+        else:
+            return self._lazy_registry.get_obj()
+    
     @staticmethod
     def from_kwargs(name_, help=None, title=None, value_switches=False,
                     enum_switch=True, **kwargs):
@@ -341,7 +356,7 @@
         RegistryOption constructor.  Any other keyword arguments are treated
         as values for the option, and they value is treated as the help.
         """
-        reg = registry.Registry()
+        reg = _mod_registry.Registry()
         for name, switch_help in kwargs.iteritems():
             name = name.replace('_', '-')
             reg.register(name, name, help=switch_help)
@@ -434,7 +449,7 @@
     Option.OPTIONS[name] = RegistryOption(name, help, registry, **kwargs)
 
 
-class MergeTypeRegistry(registry.Registry):
+class MergeTypeRegistry(_mod_registry.Registry):
 
     pass
 

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2008-01-28 16:59:52 +0000
+++ bzrlib/osutils.py	2008-02-18 08:30:38 +0000
@@ -14,7 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from cStringIO import StringIO
 import os
 import re
 import stat
@@ -59,7 +58,6 @@
     deprecated_function,
     one_zero,
     )
-from bzrlib.trace import mutter
 
 
 # On win32, O_BINARY is used to indicate the file should
@@ -286,6 +284,15 @@
 
 
 def _win32_abspath(path):
+    global _win32_abspath
+    if win32utils.winver == 'Windows 98':
+        _win32_abspath = _win98_abspath
+    else:
+        _win32_abspath = _real_win32_abspath
+    return _win32_abspath(path)
+
+
+def _real_win32_abspath(path):
     # Real _nt_abspath doesn't have a problem with a unicode cwd
     return _win32_fixdrive(_nt_abspath(unicode(path)).replace('\\', '/'))
 
@@ -316,9 +323,6 @@
         path = cwd + '\\' + path
     return _win32_fixdrive(_nt_normpath(path).replace('\\', '/'))
 
-if win32utils.winver == 'Windows 98':
-    _win32_abspath = _win98_abspath
-
 
 def _win32_realpath(path):
     # Real _nt_realpath doesn't have a problem with a unicode cwd
@@ -426,6 +430,7 @@
     On my standard US Windows XP, the preferred encoding is
     cp1252, but the console is cp437
     """
+    from bzrlib.trace import mutter
     output_encoding = getattr(sys.stdout, 'encoding', None)
     if not output_encoding:
         input_encoding = getattr(sys.stdin, 'encoding', None)

=== modified file 'bzrlib/patches.py'
--- bzrlib/patches.py	2007-08-17 17:56:35 +0000
+++ bzrlib/patches.py	2008-02-18 08:30:38 +0000
@@ -14,7 +14,6 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-import re
 
 
 class PatchSyntax(Exception):
@@ -95,6 +94,7 @@
 
  
 def hunk_from_header(line):
+    import re
     matches = re.match(r'\@\@ ([^@]*) \@\@( (.*))?\n', line)
     if matches is None:
         raise MalformedHunkHeader("Does not match format.", line)

=== modified file 'bzrlib/plugin.py'
--- bzrlib/plugin.py	2008-01-21 10:46:32 +0000
+++ bzrlib/plugin.py	2008-02-18 08:30:38 +0000
@@ -42,12 +42,12 @@
 from bzrlib import (
     config,
     osutils,
+    trace,
     )
 from bzrlib import plugins as _mod_plugins
 """)
 
 from bzrlib.symbol_versioning import deprecated_function, zero_ninetyone
-from bzrlib.trace import mutter, warning, log_exception_quietly
 
 
 DEFAULT_PLUGIN_PATH = None
@@ -151,7 +151,7 @@
     for d in dirs:
         if not d:
             continue
-        mutter('looking for plugins in %s', d)
+        trace.mutter('looking for plugins in %s', d)
         if os.path.isdir(d):
             load_from_dir(d)
         else:
@@ -193,9 +193,9 @@
             else:
                 continue
         if getattr(_mod_plugins, f, None):
-            mutter('Plugin name %s already loaded', f)
+            trace.mutter('Plugin name %s already loaded', f)
         else:
-            # mutter('add plugin name %s', f)
+            # trace.mutter('add plugin name %s', f)
             plugin_names.add(f)
     
     for name in plugin_names:
@@ -207,12 +207,12 @@
             ## import pdb; pdb.set_trace()
             if re.search('\.|-| ', name):
                 sanitised_name = re.sub('[-. ]', '_', name)
-                warning("Unable to load %r in %r as a plugin because file path"
+                trace.warning("Unable to load %r in %r as a plugin because file path"
                         " isn't a valid module name; try renaming it to %r."
                         % (name, d, sanitised_name))
             else:
-                warning('Unable to load plugin %r from %r' % (name, d))
-            log_exception_quietly()
+                trace.warning('Unable to load plugin %r from %r' % (name, d))
+            trace.log_exception_quietly()
 
 
 def load_from_zip(zip_name):
@@ -227,7 +227,7 @@
     archive = zip_name[:index+4]
     prefix = zip_name[index+5:]
 
-    mutter('Looking for plugins in %r', zip_name)
+    trace.mutter('Looking for plugins in %r', zip_name)
 
     # use zipfile to get list of files/dirs inside zip
     try:
@@ -247,7 +247,7 @@
                     for name in namelist
                     if name.startswith(prefix)]
 
-    mutter('Names in archive: %r', namelist)
+    trace.mutter('Names in archive: %r', namelist)
     
     for name in namelist:
         if not name or name.endswith('/'):
@@ -279,19 +279,19 @@
         if not plugin_name:
             continue
         if getattr(_mod_plugins, plugin_name, None):
-            mutter('Plugin name %s already loaded', plugin_name)
+            trace.mutter('Plugin name %s already loaded', plugin_name)
             continue
     
         try:
             exec "import bzrlib.plugins.%s" % plugin_name in {}
-            mutter('Load plugin %s from zip %r', plugin_name, zip_name)
+            trace.mutter('Load plugin %s from zip %r', plugin_name, zip_name)
         except KeyboardInterrupt:
             raise
         except Exception, e:
             ## import pdb; pdb.set_trace()
-            warning('Unable to load plugin %r from %r'
+            trace.warning('Unable to load plugin %r from %r'
                     % (name, zip_name))
-            log_exception_quietly()
+            trace.log_exception_quietly()
 
 
 def plugins():

=== modified file 'bzrlib/repofmt/knitrepo.py'
--- bzrlib/repofmt/knitrepo.py	2008-01-17 05:30:53 +0000
+++ bzrlib/repofmt/knitrepo.py	2008-02-18 08:30:38 +0000
@@ -18,13 +18,16 @@
 lazy_import(globals(), """
 from bzrlib import (
     debug,
+    deprecated_graph,
+    xml5,
+    xml6,
+    xml7,
     )
 from bzrlib.store import revision
 from bzrlib.store.revision.knit import KnitRevisionStore
 """)
 from bzrlib import (
     bzrdir,
-    deprecated_graph,
     errors,
     knit,
     lockable_files,
@@ -32,9 +35,6 @@
     osutils,
     symbol_versioning,
     transactions,
-    xml5,
-    xml6,
-    xml7,
     )
 
 from bzrlib.decorators import needs_read_lock, needs_write_lock
@@ -351,7 +351,9 @@
     _commit_builder_class = None
     # Set this attribute in derived clases to control the _serializer that the
     # repository objects will have passed to their constructor.
-    _serializer = xml5.serializer_v5
+    @property
+    def _serializer(self):
+        return xml5.serializer_v5
     # Knit based repositories handle ghosts reasonably well.
     supports_ghosts = True
 
@@ -468,7 +470,9 @@
 
     repository_class = KnitRepository
     _commit_builder_class = CommitBuilder
-    _serializer = xml5.serializer_v5
+    @property
+    def _serializer(self):
+        return xml5.serializer_v5
 
     def __ne__(self, other):
         return self.__class__ is not other.__class__
@@ -505,7 +509,9 @@
     _commit_builder_class = RootCommitBuilder
     rich_root_data = True
     supports_tree_reference = True
-    _serializer = xml7.serializer_v7
+    @property
+    def _serializer(self):
+        return xml7.serializer_v7
 
     def _get_matching_bzrdir(self):
         return bzrdir.format_registry.make_bzrdir('dirstate-with-subtree')
@@ -552,7 +558,9 @@
     _commit_builder_class = RootCommitBuilder
     rich_root_data = True
     supports_tree_reference = False
-    _serializer = xml6.serializer_v6
+    @property
+    def _serializer(self):
+        return xml6.serializer_v6
 
     def _get_matching_bzrdir(self):
         return bzrdir.format_registry.make_bzrdir('rich-root')

=== modified file 'bzrlib/repofmt/pack_repo.py'
--- bzrlib/repofmt/pack_repo.py	2008-01-11 03:54:51 +0000
+++ bzrlib/repofmt/pack_repo.py	2008-02-18 08:30:38 +0000
@@ -26,6 +26,9 @@
         graph,
         pack,
         ui,
+        xml5,
+        xml6,
+        xml7,
         )
 from bzrlib.index import (
     GraphIndex,
@@ -42,7 +45,6 @@
 """)
 from bzrlib import (
     bzrdir,
-    deprecated_graph,
     errors,
     knit,
     lockable_files,
@@ -50,9 +52,6 @@
     osutils,
     symbol_versioning,
     transactions,
-    xml5,
-    xml6,
-    xml7,
     )
 
 from bzrlib.decorators import needs_read_lock, needs_write_lock
@@ -2148,7 +2147,9 @@
 
     repository_class = KnitPackRepository
     _commit_builder_class = PackCommitBuilder
-    _serializer = xml5.serializer_v5
+    @property
+    def _serializer(self):
+        return xml5.serializer_v5
 
     def _get_matching_bzrdir(self):
         return bzrdir.format_registry.make_bzrdir('pack-0.92')
@@ -2184,7 +2185,9 @@
     _commit_builder_class = PackRootCommitBuilder
     rich_root_data = True
     supports_tree_reference = True
-    _serializer = xml7.serializer_v7
+    @property
+    def _serializer(self):
+        return xml7.serializer_v7
 
     def _get_matching_bzrdir(self):
         return bzrdir.format_registry.make_bzrdir(
@@ -2225,7 +2228,9 @@
     _commit_builder_class = PackRootCommitBuilder
     rich_root_data = True
     supports_tree_reference = False
-    _serializer = xml6.serializer_v6
+    @property
+    def _serializer(self):
+        return xml6.serializer_v6
 
     def _get_matching_bzrdir(self):
         return bzrdir.format_registry.make_bzrdir(

=== modified file 'bzrlib/repofmt/weaverepo.py'
--- bzrlib/repofmt/weaverepo.py	2008-01-11 03:54:51 +0000
+++ bzrlib/repofmt/weaverepo.py	2008-02-18 08:30:38 +0000
@@ -22,6 +22,12 @@
 
 from StringIO import StringIO
 
+from bzrlib.lazy_import import lazy_import
+lazy_import(globals(), """
+from bzrlib import (
+    xml5,
+    )
+""")
 from bzrlib import (
     bzrdir,
     debug,
@@ -32,8 +38,6 @@
     revision as _mod_revision,
     weave,
     weavefile,
-    xml5,
-    )
 from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.repository import (
     CommitBuilder,
@@ -49,7 +53,9 @@
 class AllInOneRepository(Repository):
     """Legacy support - the repository behaviour for all-in-one branches."""
 
-    _serializer = xml5.serializer_v5
+    @property
+    def _serializer(self):
+        return xml5.serializer_v5
 
     def __init__(self, _format, a_bzrdir, _revision_store, control_store, text_store):
         # we reuse one control files instance.
@@ -215,7 +221,9 @@
 class WeaveMetaDirRepository(MetaDirRepository):
     """A subclass of MetaDirRepository to set weave specific policy."""
 
-    _serializer = xml5.serializer_v5
+    @property
+    def _serializer(self):
+        return xml5.serializer_v5
 
     @needs_read_lock
     def _all_possible_ids(self):

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2007-12-18 17:52:11 +0000
+++ bzrlib/revision.py	2008-02-18 08:30:38 +0000
@@ -18,15 +18,13 @@
 # perhaps show them in log -v and allow them as options to the commit command.
 
 
+from bzrlib.lazy_import import lazy_import
+lazy_import(globals(), """
+from bzrlib import deprecated_graph
+""")
 from bzrlib import (
     errors,
-    symbol_versioning
-    )
-from bzrlib.deprecated_graph import (
-    all_descendants,
-    Graph,
-    node_distances,
-    select_farthest,
+    symbol_versioning,
     )
 from bzrlib.osutils import contains_whitespace
 from bzrlib.progress import DummyProgress
@@ -308,9 +306,10 @@
             raise errors.NoCommonAncestor(revision_a, revision_b)
             
         pb.update('Picking ancestor', 2, 3)
-        distances = node_distances (descendants, ancestors, root)
+        distances = deprecated_graph.node_distances(
+            descendants, ancestors, root)
         pb.update('Picking ancestor', 3, 2)
-        farthest = select_farthest(distances, common)
+        farthest = deprecated_graph.select_farthest(distances, common)
         if farthest is None or farthest == NULL_REVISION:
             raise errors.NoCommonAncestor(revision_a, revision_b)
     finally:
@@ -399,7 +398,7 @@
                                             revision_id)
 
         # combine the graphs
-        result = Graph()
+        result = deprecated_graph.Graph()
         pending = set(revision_ids)
         done = set()
         def find_parents(node_id):

=== modified file 'bzrlib/util/configobj/configobj.py'
--- bzrlib/util/configobj/configobj.py	2007-11-15 11:28:37 +0000
+++ bzrlib/util/configobj/configobj.py	2008-02-18 08:30:38 +0000
@@ -24,12 +24,12 @@
     raise RuntimeError("Python v.2.2 or later needed")
 
 import os, re
-compiler = None
-try:
-    import compiler
-except ImportError:
-    # for IronPython
-    pass
+
+from bzrlib.lazy_import import lazy_import
+lazy_import(globals(), """
+import compiler
+""")
+
 from types import StringTypes
 from warnings import warn
 try:
@@ -88,27 +88,6 @@
     None: BOM_UTF8
     }
 
-try:
-    from validate import VdtMissingValue
-except ImportError:
-    VdtMissingValue = None
-
-try:
-    enumerate
-except NameError:
-    def enumerate(obj):
-        """enumerate for Python 2.2."""
-        i = -1
-        for item in obj:
-            i += 1
-            yield i, item
-
-try:
-    True, False
-except NameError:
-    True, False = 1, 0
-
-
 __version__ = '4.4.0'
 
 __revision__ = '$Id: configobj.py 156 2006-01-31 14:57:08Z fuzzyman $'
@@ -159,8 +138,6 @@
 
 def getObj(s):
     s = "a=" + s
-    if compiler is None:
-        raise ImportError('compiler module not available')
     p = compiler.parse(s)
     return p.getChildren()[1].getChildren()[0].getChildren()[1]
 
@@ -2029,6 +2006,10 @@
             if self.configspec is None:
                 raise ValueError, 'No configspec supplied.'
             if preserve_errors:
+                try:
+                    from validate import VdtMissingValue
+                except ImportError:
+                    VdtMissingValue = None
                 if VdtMissingValue is None:
                     raise ImportError('Missing validate module.')
             section = self

=== modified file 'bzrlib/version.py'
--- bzrlib/version.py	2007-10-16 17:37:43 +0000
+++ bzrlib/version.py	2008-02-18 08:30:38 +0000
@@ -72,7 +72,7 @@
     if show_config:
         config_dir = os.path.normpath(config.config_dir())  # use native slashes
         if not isinstance(config_dir, unicode):
-            config_dir = config_dir.decode(bzrlib.user_encoding)
+            config_dir = config_dir.decode(osutils.get_user_encoding())
         to_file.write("  Bazaar configuration: %s\n" % (config_dir,))
         to_file.write("  Bazaar log file: ")
         to_file.write(trace._bzr_log_filename + '\n')

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2008-01-02 03:08:59 +0000
+++ bzrlib/weave.py	2008-02-18 08:30:38 +0000
@@ -75,6 +75,10 @@
 import time
 import warnings
 
+from bzrlib.lazy_import import lazy_import
+lazy_import(globals(), """
+from bzrlib import tsort
+""")
 from bzrlib import (
     progress,
     )
@@ -88,7 +92,6 @@
 import bzrlib.errors as errors
 from bzrlib.osutils import sha_strings
 import bzrlib.patiencediff
-from bzrlib.tsort import topo_sort
 from bzrlib.versionedfile import VersionedFile, InterVersionedFile
 from bzrlib.weavefile import _read_weave_v5, write_weave_v5
 
@@ -760,7 +763,7 @@
         version_ids = other.get_ancestry(version_ids)
         pending_graph = [(version, other.get_parents(version)) for
                          version in version_ids]
-        for name in topo_sort(pending_graph):
+        for name in tsort.topo_sort(pending_graph):
             other_idx = other._name_map[name]
             # returns True if we have it, False if we need it.
             if not self._check_version_consistent(other, other_idx, name):
@@ -940,7 +943,7 @@
     # map from version name -> all parent names
     combined_parents = _reweave_parent_graphs(wa, wb)
     mutter("combined parents: %r", combined_parents)
-    order = topo_sort(combined_parents.iteritems())
+    order = tsort.topo_sort(combined_parents.iteritems())
     mutter("order to reweave: %r", order)
 
     if pb and not msg:

